; C CALLABLE MACRO ASSEMBLER FUNCTION
; Test keyboard buffer for key hit. EG: int kbkey(void);
; On return 0 = NO  and  1 = YES.

        name   kbkey

public  _kbkey

DGROUP  group   _DATA
        assume  ds:DGROUP

_DATA   segment word    public  'DATA'
_DATA   ends


_TEXT   segment byte    public  'CODE'
        assume  cs:_TEXT

_kbkey  proc    near
        push    bp
        mov     bp, sp
        mov     ah, 1           ; Test kb buffer status
        int     16h
        mov     ax, 0
        jz      short kbexit    ; kb_buff is empty
        mov     ax, 1           ; char(s) in buffer
kbexit: mov     sp, bp
        pop     bp
        ret
_kbkey  endp

_TEXT   ends
        end

